#pragma once

#include <base/signal.h>
#include <dataspace/capability.h>
#include <session/session.h>
#include <irq_session/capability.h>

namespace Counter {

	struct Session;

	class Buffer_too_small : public Genode::Exception { };
	class Hsm_error        : public Genode::Exception { };

	using Id = Genode::String<100>;
}


struct Counter::Session : Genode::Session
{
	/**
	 * \noapi
	 */
	static const char *service_name() { return "Counter"; }

	enum { CAP_QUOTA = 2 };

	virtual ~Session() { }

	virtual Id id() const = 0;

	virtual Genode::uint64_t get() const = 0;

	virtual Genode::uint64_t increment() = 0;

	/*******************
	 ** RPC interface **
	 *******************/

	GENODE_RPC(Rpc_id,        Id,               id);
	GENODE_RPC(Rpc_get,       Genode::uint64_t, get);
	GENODE_RPC(Rpc_increment, Genode::uint64_t, increment);

	GENODE_RPC_INTERFACE(Rpc_id, Rpc_get, Rpc_increment);
};

